// Analog_Input_Scan.cpp : Defines the entry point for the console application.
//
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "windows2linux.h"
#include <termios.h>//#include <conio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>

#include "hsdaql.h"

unsigned long GetTickCount();
int msleep(int msec);
#define Sleep msleep
void changemode(int dir)
{
  static struct termios oldt, newt;
 
  if ( dir == 1 )
  {
    tcgetattr( STDIN_FILENO, &oldt);
    newt = oldt;
    newt.c_lflag &= ~( ICANON | ECHO );
    tcsetattr( STDIN_FILENO, TCSANOW, &newt);
  }
  else
    tcsetattr( STDIN_FILENO, TCSANOW, &oldt);
}
int kbhit (void)
{
  struct timeval tv;
  fd_set rdfs;
 
  tv.tv_sec = 0;
  tv.tv_usec = 0;
 
  FD_ZERO(&rdfs);
  FD_SET (STDIN_FILENO, &rdfs);
 
  select(STDIN_FILENO+1, &rdfs, NULL, NULL, &tv);
  return FD_ISSET(STDIN_FILENO, &rdfs);
 
} 
float CalibrateHex2Float(short h16Bit, int  iGain, unsigned short  g, short o)
{
	L32 lAD_Data;
	float fVal = 0;
	lAD_Data = (L32)h16Bit * g ;//(long)(g);
	lAD_Data >>= 15;
	lAD_Data += (int)o;
	if (lAD_Data > 32767)
		lAD_Data = 32767;
	else if (lAD_Data < -32768)
		lAD_Data = -32768;
	switch (iGain)
	{
		case 1:
			fVal = lAD_Data / (float)3276.8;  //==> AD/32768*10
			break;
		case 0:
			fVal = lAD_Data / (float)6553.6;  //==> AD/32768*5
			break;
	}
	return fVal;
}

int main(int argc, char *argv[])
{
	HANDLE hHS;
	//char IPadd[64]="\0";
    char *IPadd=NULL;
	char sdk_version[16]={0};
	char fw_version[32]={0};

	bool ret= false;
	short chCnt=4;
	short  useGain=0;
	unsigned short gVarr[4];
	short oVarr[4];

	short extriggMode=0;
	bool continuousMode=false;
	long continuousTimeout=0;
	unsigned int targetCnt=0;
	int sampleRate=0;


	short DataTransMethod=0;
	short AutoRun=0;
    float fAI[4];

	if(argc>1)
	{	
        printf("%d,%s\r\n",argc,argv[1]);
		//char   *pFilePathName; 
   
		//int   nLen   =   wcslen(argv[1])+1;    
		//WideCharToMultiByte(CP_ACP,   0,   argv[1],   -1,   IPadd,  64,   NULL,   NULL);
		//printf("program start %s\r\n",IPadd);
        IPadd=argv[1];
	}
	else
	{
		printf("error argument\r\n");
		return 0;
	}

	char tmp[128]={0};
	sprintf(tmp,"%s,9999,10010",IPadd);
	//Step 1: Create a TCP connection with ET-7H24

    printf("ET-7H24 Analog Input Scan Testing [N sample mode & Software trigger]\r\n");
	HS_GetSDKVersion(sdk_version);
	printf("HSDAQ SDK Ver=%s\r\n",sdk_version);
                                 
	hHS = HS_Device_Create(tmp);

	Sleep(1);
	if(hHS!=NULL)
	{
        changemode(1);
        
		HS_GetFirmwareVersion(hHS,fw_version);
		printf(">ET7H24 Firmware Ver=%s\r\n",fw_version);        
        
        for (int ch = 0; ch < 4; ch++)
        {
		//Read Gain Offset valus for each channel
		  HS_ReadGainOffset(hHS, ch,useGain, &gVarr[ch], &oVarr[ch]);
		  printf("ch : %d Gain Value : %u Offset Valus : %d\n", ch,gVarr[ch],oVarr[ch]);
        }    

		float f1AI=0;
		HS_ReadAIALL(hHS,useGain,fAI,4); //NG on linux version 
		for(int j=0;j<4;j++)
		{
		  HS_ReadAI(hHS,j,useGain,&f1AI);
		  printf("%d=%f, %f\r\n",j,fAI[j],f1AI);
		} 
        
		extriggMode=0; //software trigger
		targetCnt=512; //N sample mode: 512 counts
		sampleRate=1000; //sampling rate : 1KHz 
		ret=HS_SetAIScanParam(hHS, chCnt, useGain, extriggMode, sampleRate, targetCnt, DataTransMethod,AutoRun);
		//Step 2: SetScanParam sets chCnt, useGain, triggerMode, sampleRate, targetCnt to ET7H16
		if(ret==false)
		{
			//printf("Error code 0x%x\r\n",HS_GetLastError());
            printf("Set AIscan param failed\r\n");
		}

		HS_GetAIScanParam(hHS, &chCnt, &useGain, &extriggMode, &sampleRate, &targetCnt,&DataTransMethod,&AutoRun); 
		//Step 3: GetScanParam getsx chCnt, useGain, triggerMode, sampleRate, targetCnt to check with ET7H24
		printf("ET-7H24 first Scan parameters chCnt %d, useGain %d, triggMode %d, sampleRate %ld, targetCnt %lu \n", chCnt, useGain, extriggMode, sampleRate, targetCnt);

		Sleep(10);
#if 1  
		WORD BufferStatus=0;
		DWORD *dataBuffer;
        
        //#define BUFFERSIZE 1000        
		DWORD ulleng=0;
        DWORD readsize=0;
		unsigned long totalRecv=0;
		unsigned long otherCHcheckerror=0;			
		bool quit=false;
        int selectch=0;

		/*Test N sample mode in this demo*/
		if(targetCnt>0) //N sample mode 
		{       
			dataBuffer=(DWORD *)malloc(sizeof(DWORD)*targetCnt);
            //fdataBuffer=(float *)malloc(sizeof(float)*targetCnt);
			//Step 5: Start AI Scan            
			unsigned long t1=GetTickCount();
			//Step 4: Start AI Scan           
			ret=HS_StartAIScan(hHS);
			if(ret==false)
			{
				//printf("Error code 0x%x\r\n",HS_GetLastError());
                printf("HS_StartAIScan failed\r\n");
			}                      
	
			//Step 5: while loop to get total received data from ET7H24Logger
			while(quit==false)
			{			
				ret=HS_GetAIBufferStatus(hHS,&BufferStatus,&ulleng);
				if(ret==false)
				{
					//printf("Error code 0x%x\r\n",HS_GetLastError());
                    printf("Error code 0x%x\r\n");
				}
				else
				{
					if(BufferStatus>2) //AI buffer overflow
					{
						/* 
						   2:  AD_BUF_OVERFLOW	
						   4:  AD_SCAN_STOP
						   8:  AD_DATA_SAMPLING_TIMEOUT
						*/
						printf("Error<%d>, %lu\r\n",BufferStatus,ulleng);	
						break; 
					}
					if(ulleng==targetCnt)
					{
						//printf(">%d \r\n",ulleng);
						unsigned int size=targetCnt;	
						{							
							readsize=HS_GetAIBufferHex(hHS,(DWORD *)dataBuffer,size); 					
							
							if(readsize==targetCnt)
							{
								unsigned long t2=GetTickCount();
								printf("%lf sec\r\n",((float)t2-t1)/1000);                                                
                                                     
								for(int i=0;i<readsize;i++)
								{
                                    selectch=i%chCnt;              
                                    //printf("%d, 0x%X\r\n",i,dataBuffer[i]);   
                                    float fdata=CalibrateHex2Float(dataBuffer[i],useGain, gVarr[selectch], oVarr[selectch]);     
                                    printf("ch%d =%f\r\n",selectch,fdata);            
								/*	switch(i%chCnt)
									{	//check channel1/3 only
										case 1: 
										case 3:
										/*if(fdata>(fAI[1]+0.01) || dataBuffer[i]<(fAI[1]-0.01)
										{
											CH1checkerror++;
											printf("CH%d error %lu, %f\r\n",i%chCnt, otherCHcheckerror,fdata);											
                                            otherCHcheckerror++;
                                            quit=true;																				
										}*
										break; 
									}
                                */
								}																
							}
							else
							{     
								printf("Get AI buffer error\r\n");
							}
						}
						break;
					}
				}
				//continue mode
			     if(kbhit())
			     {
                    char ch=getchar();
                    printf("%c",ch); 
                    if(ch=='q' || ch=='Q')
                        //goto END;
					   break;									
			     }               
			}
		
			printf("AP total read %lu Error check %lu\n", readsize,otherCHcheckerror);
			//Step6: Stop AI Scan
			HS_StopAIScan(hHS);            
			free(dataBuffer);           
		}                      
#endif         
		//Step7: Close the connection
END:        
		HS_Device_Release(hHS);
        changemode(0);       
	}                      
	return 0;
}

