// Digital_IO.cpp : Defines the entry point for the console application.
//

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "windows2linux.h"
#include <termios.h>//#include <conio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>

#include "hsdaql.h"

void changemode(I32 dir)
{
  static struct termios oldt, newt;
 
  if ( dir == 1 )
  {
    tcgetattr( STDIN_FILENO, &oldt);
    newt = oldt;
    newt.c_lflag &= ~( ICANON | ECHO );
    tcsetattr( STDIN_FILENO, TCSANOW, &newt);
  }
  else
    tcsetattr( STDIN_FILENO, TCSANOW, &oldt);
}
         
 
UL32 GetTickCount();
I32 msleep(L32 msec);
#define Sleep msleep


#define MENU_EXIT		0
#define IO_READ_DIO			1
#define IO_WRITE_DO			2
#define IO_CLEAR_DO			3
#define IO_WRITE_AO			4

#define	OPTION_MAX		5


I32 menu(I32* opt) {
	char input[10];
	printf("==== DIO Menus ====\n");
	printf("Test Menus:\n");

	printf("%2d)Read DI/DO\n", IO_READ_DIO);
	printf("%2d)Write DO\n", IO_WRITE_DO);
	printf("%2d)Clear DO\n", IO_CLEAR_DO);
	printf("%2d)Write AO\n", IO_WRITE_AO);
	printf("%2d)Quit\n", MENU_EXIT);
	
	printf("Please Enter option\n");
	fgets(input, 10, stdin);
	*opt = atoi(input);
	if (*opt < 0 || *opt >= OPTION_MAX)
		return 1;
	else
		return 0;
}

I32 main(I32 argc, char *argv[])
{
	HANDLE hHS;
    char *IPadd=NULL;
	char sdk_version[32];
	DWORD dwDI=0,dwDO=0;
	I32 opt=0;
	I32 error_code = 1;
	I32 AOch;

	if(argc>1)
	{
		printf("%d,%s\r\n",argc,argv[1]);
        IPadd=argv[1];

		if(menu(&opt))
		{
			printf("error option\r\n");
			return 0;
		}
	}
	else
	{
		printf("error argument\r\n");
		return 0;
	}

	//Step 2: AddCmdClient and get cmd socket
	char tmp[128]={0};
	float fvalue=0;
	char input[10];
	sprintf(tmp,"%s,9999,10010",IPadd);
	hHS = HS_Device_Create(tmp);

	Sleep(25);
	if(hHS!=NULL)
	{
		printf("ET-7H24 Basic I/O Testing\r\n");
		HS_GetSDKVersion(sdk_version);
		printf("ver=%s\r\n",sdk_version);


		while (opt != MENU_EXIT)
		{
			switch (opt)
			{
				case IO_READ_DIO:					
					HS_ReadDIO(hHS,&dwDI,&dwDO);
					printf("Read DI=%x, DO=%x\r\n",dwDI,dwDO);
					break;
				case IO_WRITE_DO:
					printf("Please input DO(0x00~0xFF)\n");
					fgets(input, 10, stdin);
		
					dwDO = (I32)strtol(input, NULL, 16);
					printf("Write DO: 0x%X\n",dwDO);
					HS_WriteDO(hHS,dwDO);
					break;
				case IO_CLEAR_DO:
					HS_WriteDO(hHS,0);
					break;
				case IO_WRITE_AO:					
					printf("Please input AO channel(0 ~ 1)\n");
					fgets(input, 10, stdin);
					AOch=atoi(input);
					printf("Please input AO value(-10.0~10.0)\n");
					fgets(input, 10, stdin);
					fvalue=atof(input);
					printf("Write AO: %f\n",fvalue);
					HS_WriteAO(hHS, AOch, 0, fvalue); //type 0: 10 V					
					break;
				case MENU_EXIT:
					goto __exit__;
			}
			getchar();
			if(menu(&opt))
				break;
		}
__exit__:
		HS_Device_Release(hHS);
	}
	return 0;
}

