// Analog_Input_Scan.cpp : Defines the entry point for the console application.
//
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "windows2linux.h"
#include <termios.h>//#include <conio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>

#include "hsdaql.h"


void changemode(int dir)
{
  static struct termios oldt, newt;
 
  if ( dir == 1 )
  {
    tcgetattr( STDIN_FILENO, &oldt);
    newt = oldt;
    newt.c_lflag &= ~( ICANON | ECHO );
    tcsetattr( STDIN_FILENO, TCSANOW, &newt);
  }
  else
    tcsetattr( STDIN_FILENO, TCSANOW, &oldt);
}
 
int kbhit (void)
{
  struct timeval tv;
  fd_set rdfs;
 
  tv.tv_sec = 0;
  tv.tv_usec = 0;
 
  FD_ZERO(&rdfs);
  FD_SET (STDIN_FILENO, &rdfs);
 
  select(STDIN_FILENO+1, &rdfs, NULL, NULL, &tv);
  return FD_ISSET(STDIN_FILENO, &rdfs);
 
}            
 
unsigned long GetTickCount();
int msleep(long msec);
#define Sleep msleep

int main(int argc, char *argv[])
{
	HANDLE hHS;
	//char IPadd[64]="\0";
    char *IPadd=NULL;
	char sdk_version[16]={0};
	char fw_version[32]={0};

	bool ret= false;
	short chCnt=8;
	short  useGain=0;


	short extriggMode=0;
	bool continuousMode=false;
	long continuousTimeout=0;
	unsigned long targetCnt=0;
	long sampleRate=0;

	//unsigned long totalRead=0,totalReceived=0;
	short DataTransMethod=0;
	short AutoRun=0;
    float fAI[8];

	if(argc>1)
	{	
        printf("%d,%s\r\n",argc,argv[1]);
		//char   *pFilePathName; 
   
		//int   nLen   =   wcslen(argv[1])+1;    
		//WideCharToMultiByte(CP_ACP,   0,   argv[1],   -1,   IPadd,  64,   NULL,   NULL);
		//printf("program start %s\r\n",IPadd);
        IPadd=argv[1];
	}
	else
	{
		printf("error argument\r\n");
		return 0;
	}

	char tmp[128]={0};
	sprintf(tmp,"%s,9999,10010",IPadd);
	//Step 1: Create a TCP connection with ET-7H16

    printf("ET-7H16 Analog Input Scan Testing [N sample mode & Software trigger]\r\n");
	HS_GetSDKVersion(sdk_version);
	printf("HSDAQ SDK Ver=%s\r\n",sdk_version);
    changemode(1); 
    
	hHS = HS_Device_Create(tmp);

	Sleep(1);
	if(hHS!=NULL)
	{
		HS_GetFirmwareVersion(hHS,fw_version);
		printf("ET7H16 Firmware Ver=%s\r\n",fw_version);

		/*float f1AI=0;
		HS_ReadAIALL(hHS,fAI,8);
		for(int j=0;j<8;j++)
		{
		  HS_ReadAI(hHS,j,&f1AI);
		  printf("%d=%f, %f\r\n",j,fAI[j],f1AI);
		} */
        
		extriggMode=0; //software trigger
		//targetCnt=10000; //N sample mode: 10000 counts
        targetCnt=0; //N sample mode: 10000 counts
		sampleRate=100; //sampling rate : 1KHz 
		ret=HS_SetAIScanParam(hHS, chCnt, useGain, extriggMode, sampleRate, targetCnt, DataTransMethod,AutoRun);
		//Step 2: SetScanParam sets chCnt, useGain, triggerMode, sampleRate, targetCnt to ET7H16
		if(ret==false)
		{
			//printf("Error code 0x%x\r\n",HS_GetLastError());
            printf("Set AIscan param failed\r\n");
		}

		HS_GetAIScanParam(hHS, &chCnt, &useGain, &extriggMode, &sampleRate, &targetCnt,&DataTransMethod,&AutoRun); 
		//Step 3: GetScanParam getsx chCnt, useGain, triggerMode, sampleRate, targetCnt to check with ET7H16
		printf("ET-7H16 first Scan parameters chCnt %d, useGain %d, triggMode %d, sampleRate %ld, targetCnt %lu \n", chCnt, useGain, extriggMode, sampleRate, targetCnt);

		Sleep(10);
#if 1  
		WORD BufferStatus=0;
		unsigned long *dataBuffer;
        
        //#define BUFFERSIZE 1000        
		//float *fdataBuffer;
		unsigned long ulleng=0;
		unsigned long totalRecv=0;
		unsigned long otherCHcheckerror=0;
		unsigned long readsize=0;	
		bool quit=false;


		{     
            //fdataBuffer=(float *)malloc(sizeof(float)*targetCnt);
			//Step 5: Start AI Scan            
			DWORD t1=GetTickCount();
			//Step 4: Start AI Scan           
			ret=HS_StartAIScan(hHS);
			if(ret==false)
			{
				//printf("Error code 0x%x\r\n",HS_GetLastError());
                printf("HS_StartAIScan failed\r\n");
			}

	
			//Step 5: while loop to get total received data from ET7H16Logger
			while(quit==false)
			{			
				ret=HS_GetAIBufferStatus(hHS,&BufferStatus,&ulleng);
				if(ret==false)
				{
					//printf("Error code 0x%x\r\n",HS_GetLastError());
                    printf("Error code 0x%x\r\n");
				}
				else
				{
					if(BufferStatus>2) //AI buffer overflow
					{
						/* 
						   2:  AD_BUF_OVERFLOW	
						   4:  AD_SCAN_STOP
						   8:  AD_DATA_SAMPLING_TIMEOUT
						*/
						printf("Error<%d>, %lu\r\n",BufferStatus,ulleng);	
						break; 
					}
					if(ulleng>0)
					{
						//printf(">%d \r\n",ulleng);
						unsigned long size=ulleng;	
						{
                            dataBuffer=(unsigned long *)malloc(sizeof(unsigned long)*size);							
							readsize=HS_GetAIBufferHex(hHS,(DWORD *)dataBuffer,size);
                            //readsize=HS_GetAIBuffer(hHS,fdataBuffer,size);						
							
							//if(readsize==targetCnt)
                            if(readsize>0)
							{                          
								for(int i=0;i<readsize;i++)
								{
                                    //printf("ch%d =0x%x\r\n",i%chCnt, dataBuffer[i]);
                                       printf("readsize=%lu\r\n",readsize);                                                                        
								/*	switch(i%chCnt)
									{	//check channel 1/3/7 only
										case 1: //1.15V 0x1d5a
										case 3:
										/*if(dataBuffer[i]>0x1d6c || dataBuffer[i]<0x1d46)
										{
											CH1checkerror++;
											printf("CH1 error %lu, %X\r\n",CH1checkerror,dataBuffer[i]);
											quit=true;																				
										}*
										break;
										case 7: //0V
										/*if(dataBuffer[i]>0x10 || dataBuffer[i]<0)
										{
											CH7checkerror++;
											printf("CH7 error %lu, %X\r\n",CH7checkerror,dataBuffer[i]);										
											quit=true;
										}*
										break;
									}
                                */
								}																
							}
                            free(dataBuffer);
						}
					
					}
				}
				//continue mode                
				if(kbhit())
				{
					//Sleep(1);
                    char ch=getchar();
                    printf("%c",ch);
					//if(getchar()=='q' || getchar()=='Q')
                    if(ch=='q' || ch=='Q')
                        //goto END;
						break;
				}						
			}
		
			printf("AP total read %lu Error check %lu\n", readsize,otherCHcheckerror);
			//Step6: Stop AI Scan
			HS_StopAIScan(hHS);        
            //free(fdataBuffer);           
		}                      
#endif         
		//Step7: Close the connection
END:    
		HS_Device_Release(hHS);               
	}
    changemode(0);    
	return 0;
}

