// Analog_Input_Scan.cpp : Defines the entry point for the console application.
//
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "windows2linux.h"
#include <termios.h>//#include <conio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>

#include "hsdaql.h"

void changemode(int dir)
{
  static struct termios oldt, newt;
 
  if ( dir == 1 )
  {
    tcgetattr( STDIN_FILENO, &oldt);
    newt = oldt;
    newt.c_lflag &= ~( ICANON | ECHO );
    tcsetattr( STDIN_FILENO, TCSANOW, &newt);
  }
  else
    tcsetattr( STDIN_FILENO, TCSANOW, &oldt);
}
 
int kbhit (void)
{
  struct timeval tv;
  fd_set rdfs;
 
  tv.tv_sec = 0;
  tv.tv_usec = 0;
 
  FD_ZERO(&rdfs);
  FD_SET (STDIN_FILENO, &rdfs);
 
  select(STDIN_FILENO+1, &rdfs, NULL, NULL, &tv);
  return FD_ISSET(STDIN_FILENO, &rdfs);
 
} 

unsigned long GetTickCount();
int msleep(long msec);
#define Sleep msleep

int main(int argc, char *argv[])
{
	HANDLE hHS;
    char *IPadd=NULL;
	char sdk_version[16]={0};
	char fw_version[32]={0};

	bool ret= false;
	short chCnt=4;
	short  useGain=0;


	short extriggMode=0;
	bool continuousMode=false;
	long continuousTimeout=0;
	unsigned long targetCnt=0;
	long sampleRate=0;

	//unsigned long totalRead=0,totalReceived=0;
	short DataTransMethod=0;
	short AutoRun=0;

	if(argc>1)
	{
		printf("%d,%s\r\n",argc,argv[1]);
        IPadd=argv[1];
	}
	else
	{
		printf("error argument\r\n");
		return 0;
	}

	char tmp[128]={0};
	sprintf(tmp,"%s,9999,10010",IPadd);
	//Step 1: Create a TCP connection with ET-7H24
	hHS = HS_Device_Create(tmp);

	Sleep(10);
	if(hHS!=NULL)
	{
		printf("ET-7H24 Analog Input Scan Testing [N sample mode & Software trigger]\r\n");
		HS_GetSDKVersion(sdk_version);
		printf("HSDAQ SDK Ver=%s\r\n",sdk_version);

		HS_GetFirmwareVersion(hHS,fw_version);
		printf("ET7H24 Firmware Ver=%s\r\n",fw_version);
		
        changemode(1);
                
		extriggMode=0;
		targetCnt=50;
		sampleRate=35000; 
		ret=HS_SetAIScanParam(hHS, chCnt, useGain, extriggMode, sampleRate, targetCnt, DataTransMethod,AutoRun);
		//Step 2: SetScanParam sets chCnt, useGain, triggerMode, sampleRate, targetCnt to ET7H24
            /* For details, please refer to the API manual
             * AI CH input Range : 1 ~ 4
             * Gain Range        : 0 ~ 9
             * Mode Range        : 0 B 6
             * Sample rate       : 20 ~ 60K (continue mode)
             * targetcnt         : 4000 (N-Sample mode)
            */
		if(ret==false)
		{
			printf("Error code 0x%x\r\n",HS_GetLastError());
		}

		HS_GetAIScanParam(hHS, &chCnt, &useGain, &extriggMode, &sampleRate, &targetCnt,&DataTransMethod,&AutoRun); 
		//Step 3: GetScanParam getsx chCnt, useGain, triggerMode, sampleRate, targetCnt to check with ET7H24
		printf("ET-7H24 first Scan parameters chCnt %d, useGain %d, triggMode %d, sampleRate %ld, targetCnt %lu \n", chCnt, useGain, extriggMode, sampleRate, targetCnt);

		Sleep(10);

		WORD BufferStatus=0;
		//#define BUFFERSIZE 29200
		//short *dataBuffer;
		float *fdataBuffer;
		unsigned long ulleng=0;
		unsigned long totalRecv=0;
		unsigned long CH1checkerror=0;
		unsigned long CH7checkerror=0;
		unsigned long otherCHcheckerror=0;
		unsigned long readsize=0;	
		bool quit=false;

		/*Test N sample mode in this demo*/
		if(targetCnt>0) //N sample mode 
		{
			fdataBuffer=(float *)malloc(sizeof(float)*targetCnt);
			//Step 5: Start AI Scan
			DWORD t1=GetTickCount();
			//Step 4: Start AI Scan
			ret=HS_StartAIScan(hHS);
			if(ret==false)
			{
				printf("Error code 0x%x\r\n",HS_GetLastError());
			}

	
			//Step 5: while loop to get total received data from ET7H24Logger
			while(quit==false)
			{			
				ret=HS_GetAIBufferStatus(hHS,&BufferStatus,&ulleng);
				if(ret==false)
				{
					printf("Error code 0x%x\r\n",HS_GetLastError());
				}
				else
				{
					if(BufferStatus>2) //AI buffer overflow
					{
						/* 
						   2:  AD_BUF_OVERFLOW	
						   4:  AD_SCAN_STOP
						   8:  AD_DATA_SAMPLING_TIMEOUT
						*/
						printf("Error<%d>, %lu\r\n",BufferStatus,ulleng);	
						break; 
					}
					if(ulleng==targetCnt)
					{
						//printf(">%d \r\n",ulleng);
						unsigned long size=targetCnt;	
						{													
							readsize=HS_GetAIBuffer(hHS,fdataBuffer,size);	
							
							if(readsize==targetCnt)
							{
								printf("%lu data,",readsize);
								DWORD t2=GetTickCount();
								printf("%lf sec\r\n",((float)t2-t1)/1000);

								for(int i=0;i<readsize;i++)
								{
									if (i % chCnt == chCnt - 1)
										printf("%7.4f\r\n",fdataBuffer[i]);
									else
										printf("%7.4f\t",i,fdataBuffer[i]);
								}
																
							}
							else
							{
								printf("%d \r\n",readsize);
								printf("Get AI buffer error\r\n");
							}
						}
						break;
					}
				}
				//continue mode 
			     if(kbhit())
			     {
                    char ch=getchar();
                    printf("%c",ch);
				    //if(getchar()=='q' || getchar()=='Q')
                    if(ch=='q' || ch=='Q')
                        //goto END;
					   break;									
			     }  						
			}
		
			printf("AP total read %lu\n", readsize);
			//Step6: Stop AI Scan
			HS_StopAIScan(hHS);
			free(fdataBuffer);
		}
		//Step7: Close the connection
		HS_Device_Release(hHS);
	}
	return 0;

}

