// Analog_Input_Scan.cpp : Defines the entry point for the console application.
//

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "windows2linux.h"
#include <termios.h>//#include <conio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>

#include "hsdaql.h"

void changemode(int dir)
{
  static struct termios oldt, newt;
 
  if ( dir == 1 )
  {
    tcgetattr( STDIN_FILENO, &oldt);
    newt = oldt;
    newt.c_lflag &= ~( ICANON | ECHO );
    tcsetattr( STDIN_FILENO, TCSANOW, &newt);
  }
  else
    tcsetattr( STDIN_FILENO, TCSANOW, &oldt);
}
 
int kbhit (void)
{
  struct timeval tv;
  fd_set rdfs;
 
  tv.tv_sec = 0;
  tv.tv_usec = 0;
 
  FD_ZERO(&rdfs);
  FD_SET (STDIN_FILENO, &rdfs);
 
  select(STDIN_FILENO+1, &rdfs, NULL, NULL, &tv);
  return FD_ISSET(STDIN_FILENO, &rdfs);
 
}            
 
unsigned long GetTickCount();
int msleep(long msec);
#define Sleep msleep


#define MENU_EXIT			0
#define EC_MODE				1
#define EC_SET_LPF			2
#define EC_SET_XOR			3
#define EC_RUN				4

#define	OPTION_MAX		5


int menu(int* opt) {
	char input[10];
	printf("==== DIO Menus ====\n");
	printf("Test Menus:\n");

	printf("%2d)Set Mode\n", EC_MODE);
	printf("%2d)Set Low pass filter\n", EC_SET_LPF);
	printf("%2d)Set Xor\n", EC_SET_XOR);
	printf("%2d)Run\n", EC_RUN);
	printf("%2d)Quit\n", MENU_EXIT);
	
	printf("Please Enter option\n");
	fgets(input, 10, stdin);
	*opt = atoi(input);
	if (*opt < 0 || *opt >= OPTION_MAX)
		return 1;
	else
		return 0;
}

int main(int argc, char *argv[])
{
	HANDLE hHS;
    char *IPadd=NULL;
	char sdk_version[16]={0};
	char fw_version[32]={0};

	bool ret= false;
	int opt=0;
	int error_code = 1;


	if(argc>1)
	{
		printf("%d,%s\r\n",argc,argv[1]);
        IPadd=argv[1];
        
		if(menu(&opt))
		{
			printf("error option\r\n");
			return 0;
		}
	}
	else
	{
		printf("error argument\r\n");
		return 0;
	}
	
	char tmp[128]={0};
	sprintf(tmp,"%s,9999,10010",IPadd);
	//Step 2: Create a TCP connection with ET-7H24
	hHS = HS_Device_Create(tmp);

	Sleep(10);
	if(hHS!=NULL)
	{
		printf("ET-7H24 Encoder functions (ET-7H24 has 1 encoder channel)\r\n");
		HS_GetSDKVersion(sdk_version);
		printf("HSDAQ SDK Ver=%s\r\n",sdk_version);

		HS_GetFirmwareVersion(hHS,fw_version);
		printf("ET7H24 Firmware Ver=%s\r\n",fw_version);
		
		HS_GetHWFirmwareVersion(hHS,fw_version);
		printf("ET7H24 FPGA Firmware Ver=%s\r\n",fw_version);
	

		//Step 4: Set Encoder configuration
        int ch = 0, Mode = 0, LPF_Mode = 0, Xor_Mode = 0;
        unsigned long ENC_val = 0;
		char input[10];

		HS_ClearEncoder(hHS,ch);
		Sleep(10);
		printf("HS_ClearEncoder \r\n");

		while (opt != MENU_EXIT)
		{
			switch (opt)
			{
				case EC_MODE:				
					printf("\nInput Mode 0 ~ 2\n");
                    printf("[0] CW/CCW\n");
                    printf("[1] DIR/PLS\n");
                    printf("[2] A/B Phase\n");
					fgets(input, 10, stdin);
                    Mode =atoi(input);
					break;
				case EC_SET_LPF:
					printf("\nInput LPF Mode 0 ~ 8\n");
                    printf("[0] Disable\n");
                    printf("[1] 3.6 MHz\n");
                    printf("[2] 1.8 MHz\n");
                    printf("[3] 950 KHz\n");
                    printf("[4] 480 KHz\n");
                    printf("[5] 240 KHz\n");
                    printf("[6] 120 KHz\n");
                    printf("[7] 60  KHz\n");
                    printf("[8] 60  KHz\n");
					fgets(input, 10, stdin);
                    LPF_Mode =atoi(input);
					break;
				case EC_SET_XOR:
					printf("\nInput Xor Mode 0 ~ 3\n");
                    printf("[0] A disable , B disable\n");
                    printf("[1] A enable  , B disable\n");
                    printf("[2] A disable , B enable\n");
                    printf("[3] A enable  , B enable\n");
					fgets(input, 10, stdin);
                    Xor_Mode = atoi(input);
					break;

				case EC_RUN:					
					printf("Run Encoder\n");
					HS_SetEncoderMode(hHS, ch, Mode, LPF_Mode, Xor_Mode);				
					break;
				case MENU_EXIT:
					goto __exit__;
			}			
			getchar();
			if(menu(&opt))
				break;
		}

		printf("\nPress 'Q' to stop...\n");
        while (true)
        {
			HS_ReadEncoder(hHS, ch, &ENC_val);
            printf("\rENC value :%lu\n",ENC_val);
            Sleep(500);

			if(kbhit())
			{
                char ch=getchar();
                printf("%c",ch);
				//if(getchar()=='q' || getchar()=='Q')
                if(ch=='q' || ch=='Q')
                    //goto END;
					break;									
			} 
        }
__exit__:
		printf("Encoder End\r\n");
		HS_Device_Release(hHS);
	}
	return 0;

}

