// Digital_IO.cpp : Defines the entry point for the console application.
//
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "windows2linux.h"
#include <termios.h>//#include <conio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>

#include "hsdaql.h"


void changemode(int dir)
{
  static struct termios oldt, newt;
 
  if ( dir == 1 )
  {
    tcgetattr( STDIN_FILENO, &oldt);
    newt = oldt;
    newt.c_lflag &= ~( ICANON | ECHO );
    tcsetattr( STDIN_FILENO, TCSANOW, &newt);
  }
  else
    tcsetattr( STDIN_FILENO, TCSANOW, &oldt);
}
 
int kbhit (void)
{
  struct timeval tv;
  fd_set rdfs;
 
  tv.tv_sec = 0;
  tv.tv_usec = 0;
 
  FD_ZERO(&rdfs);
  FD_SET (STDIN_FILENO, &rdfs);
 
  select(STDIN_FILENO+1, &rdfs, NULL, NULL, &tv);
  return FD_ISSET(STDIN_FILENO, &rdfs);
 
}            
 
unsigned long GetTickCount();
int msleep(long msec);
#define Sleep msleep

int main(int argc, char *argv[])
{
	HANDLE hHS;
    char *IPadd=NULL;
	char sdk_version[32];
	DWORD dwDI=0,dwDO=0;

	if(argc>1)
	{	
        printf("%d,%s\r\n",argc,argv[1]);
		//char   *pFilePathName; 
   
		//int   nLen   =   wcslen(argv[1])+1;    
		//WideCharToMultiByte(CP_ACP,   0,   argv[1],   -1,   IPadd,  64,   NULL,   NULL);
		//printf("program start %s\r\n",IPadd);
        IPadd=argv[1];
	}
	else
	{
		printf("error argument\r\n");
		return 0;
	}

	//Step 2: AddCmdClient and get cmd socket
	char tmp[128]={0};
	sprintf(tmp,"%s,9999,10010",IPadd);
	hHS = HS_Device_Create(tmp);

	Sleep(25);
	if(hHS!=NULL)
	{
		printf("ET-7H16 Digital I/O Testing\r\n");
		HS_GetSDKVersion(sdk_version);
		printf("ver=%s\r\n",sdk_version);

		HS_ReadDIO(hHS,&dwDI,&dwDO);
		printf("Read DI=%x, DO=%x\r\n",dwDI,dwDO);
		printf("Write 0x3 to Digital output, press any key to continue...\r\n",dwDI,dwDO);
		
		getchar();
		HS_WriteDO(hHS,0x3);

		HS_ReadDIO(hHS,&dwDI,&dwDO);
		printf("Read DI=%x, DO=%x\r\n",dwDI,dwDO);
		HS_Device_Release(hHS);
	}
	return 0;
}

