// AnalogInputTrigger_AI_Scan.cpp : Defines the entry point for the console application.
//

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "windows2linux.h"
#include <termios.h>//#include <conio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>

#include "hsdaql.h"

void changemode(int dir)
{
  static struct termios oldt, newt;
 
  if ( dir == 1 )
  {
    tcgetattr( STDIN_FILENO, &oldt);
    newt = oldt;
    newt.c_lflag &= ~( ICANON | ECHO );
    tcsetattr( STDIN_FILENO, TCSANOW, &newt);
  }
  else
    tcsetattr( STDIN_FILENO, TCSANOW, &oldt);
}
 
int kbhit (void)
{
  struct timeval tv;
  fd_set rdfs;
 
  tv.tv_sec = 0;
  tv.tv_usec = 0;
 
  FD_ZERO(&rdfs);
  FD_SET (STDIN_FILENO, &rdfs);
 
  select(STDIN_FILENO+1, &rdfs, NULL, NULL, &tv);
  return FD_ISSET(STDIN_FILENO, &rdfs);
 
}  

unsigned long GetTickCount();
int msleep(long msec);
#define Sleep msleep

#define TOTALAICH	4
int main(int argc, char *argv[])
{
    HANDLE hHS;
    char *IPadd=NULL;
	int temp;
	bool ret = false;
	char str[50];
	int ch = 0;
	unsigned short gVal = 0;
	short oVal = 0;
	unsigned short gVarr[TOTALAICH];
	short oVarr[TOTALAICH];
	short ChCnt = 4;
	short Gain = 0;
	short TrigMode = 6; //6 : Analog Input Mode
	long sampleRate = 0;
	unsigned long targetCnt = 0;
	short DataTransMethod = 0;
	short AutoRun = 0;
	unsigned int Status = 0;
	unsigned int readsize = 0;
	unsigned long totalRecv = 0;
	unsigned long Reserv = 0;
	unsigned int i = 0;
	int analogmode=-1;
	int file_count=0;
	char En_Channel[TOTALAICH];
	float hightriglevel[TOTALAICH];
	float lowtriglevel[TOTALAICH];
	unsigned long leftsidecnt=0;
	unsigned long rightsidecnt=0;

	if(argc>1)
	{
		printf("%d,%s\r\n",argc,argv[1]);
        IPadd=argv[1];
	}
	else
	{
		printf("error argument\r\n");
		return 0;
	}

	char tmp[128]={0};
	sprintf(tmp,"%s,9999,10010",IPadd);
	//Step 1: Create a TCP connection with ET-7H24
	hHS = HS_Device_Create(tmp);

	Sleep(10);
	if(hHS!=NULL)
	{
		printf("PET-7H24M Analog Input Trigger demo\n");

		HS_GetSDKVersion(str);
		printf("HSDAQ SDK Version = %s\n", str);
		HS_GetFirmwareVersion(hHS,str);
		printf("ET7H24 Firmware Versoin = %s\n",str);
        
        changemode(1);
        
		for (ch = 0; ch < TOTALAICH; ch++)
		{
			//Read Gain Offset valus for each channel
			HS_ReadGainOffset(hHS, ch, Gain, &gVal, &oVal);
			printf("ch : %d Gain Value : %u Offset Valus : %d\n", ch,gVal,oVal);
			gVarr[ch] = gVal;
			oVarr[ch] = oVal;
		}
            /* For details, please refer to the API manual
             * AI CH input Range : 1 ~ 4
             * Gain Range        : 0 ~ 9
             * Mode Range        : 0 ~ 6
             * Sample rate       : 20 ~ 60K (continue mode)
             * targetcnt         : 0 (continue mode)
             * AI trigger mode   : 0 ~ 3
             *    0:  Above
                  1:  Below
                  2:  Out-Range
                  3:  In-Range
            */
		sampleRate= 10000;
		analogmode = 2;
		targetCnt = 4000;
		leftsidecnt = 0;
		rightsidecnt = 4000;
		for (ch = 0; ch < TOTALAICH; ch++)
			En_Channel[ch]=true;
		for (ch = 0; ch < TOTALAICH; ch++)
			hightriglevel[ch]=2;
		for (ch = 0; ch < TOTALAICH; ch++)
			lowtriglevel[ch]=1.5;


		ret = HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun);
		if (!ret)
		{
			printf("HS_SetAIScanParam failed Error code1 0x%x \n", HS_GetLastError());
			return 0;
		}
		ret = HS_SetAIAnalogTriggerParam(hHS,analogmode,En_Channel,hightriglevel,lowtriglevel,ChCnt,leftsidecnt,rightsidecnt,0);
		if (!ret)
		{
			printf("HS_SetAIDelayTriggerParam failed Error code1 0x%x",HS_GetLastError());
			return 0;
		}
		else
		{
			HS_GetAIScanParam(hHS, &ChCnt, &Gain, &TrigMode, &sampleRate, &targetCnt, &DataTransMethod, &AutoRun);
			HS_GetAIAnalogTriggerParam(hHS,&analogmode,En_Channel,hightriglevel,lowtriglevel,ChCnt,&leftsidecnt,&rightsidecnt,&Reserv);
			printf("Get AI Scan : Ch count = %d Gain = %d TrigMode = %d sampleRate = %lu targetCnt = %lu\n",ChCnt,Gain,TrigMode,sampleRate,targetCnt);
			printf("Analog Input Trigger Mode = %d Before-Trigger-Counts = %lu After-Trigger-Counts = %lu\n",analogmode,leftsidecnt,rightsidecnt);
			for(ch=0;ch<TOTALAICH;ch++)
			{
				if(En_Channel[ch]==1)
					printf("CH %d Enable High Limit %2.3f Low Limit %2.3f\n",ch,hightriglevel[ch],lowtriglevel[ch]);
				else
					printf("CH %d Disable High Limit %2.3f Low Limit %2.3f\n",ch,hightriglevel[ch],lowtriglevel[ch]);
			}
			Sleep(10);

			WORD BufferStatus=0;
		//#define BUFFERSIZE 29200
		//short *dataBuffer;
			float *fdataBuffer;
			unsigned long ulleng=0;
			unsigned long totalRecv=0;
			unsigned long CH1checkerror=0;
			unsigned long CH7checkerror=0;
			unsigned long otherCHcheckerror=0;
			unsigned long readsize=0;	
			bool quit=false;

		/*Test N sample mode in this demo*/
		if(targetCnt>0) //N sample mode 
		{
			fdataBuffer=(float *)malloc(sizeof(float)*targetCnt);
			//Step 5: Start AI Scan
			DWORD t1=GetTickCount();
			//Step 4: Start AI Scan
			ret=HS_StartAIScan(hHS);
			if(ret==false)
			{
				printf("Error code 0x%x\r\n",HS_GetLastError());
			}

	
			//Step 5: while loop to get total received data from ET7H24Logger
			while(quit==false)
			{			
				ret=HS_GetAIBufferStatus(hHS,&BufferStatus,&ulleng);
				if(ret==false)
				{
					printf("Error code 0x%x\r\n",HS_GetLastError());
				}
				else
				{
					if(BufferStatus>2) //AI buffer overflow
					{
						/* 
						   2:  AD_BUF_OVERFLOW	
						   4:  AD_SCAN_STOP
						   8:  AD_DATA_SAMPLING_TIMEOUT
						*/
						printf("Error<%d>, %lu\r\n",BufferStatus,ulleng);	
						break; 
					}
					if(ulleng==targetCnt)
					{
						//printf(">%d \r\n",ulleng);
						unsigned long size=targetCnt;	
						{													
							readsize=HS_GetAIBuffer(hHS,fdataBuffer,size);	
							
							if(readsize==targetCnt)
							{
								printf("%lu data,",readsize);
								DWORD t2=GetTickCount();
								printf("%lf sec\r\n",((float)t2-t1)/1000);

								for(int i=0;i<readsize;i++)
								{
									if (i % ChCnt == ChCnt - 1)
										printf("%7.4f\r\n",fdataBuffer[i]);
									else
										printf("%7.4f\t",i,fdataBuffer[i]);
								}
																
							}
							else
							{
								printf("%d \r\n",readsize);
								printf("Get AI buffer error\r\n");
							}
						}
						break;
					}
				}
    				//continue mode 
    	   		if(kbhit())
	   	       	{
                    char ch=getchar();
                    printf("%c",ch);
				    //if(getchar()=='q' || getchar()=='Q')
                    if(ch=='q' || ch=='Q')
                        //goto END;
					   break;									
			     } 						
			}
		
			printf("AP total read %lu\n", readsize);
			//Step6: Stop AI Scan
			HS_StopAIScan(hHS);
			free(fdataBuffer);
		}
		//Step7: Close the connection
	}
	HS_Device_Release(hHS);
	}
	return 0;
}
