// Analog_Input_Scan.cpp : Defines the entry point for the console application.
//
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "windows2linux.h"
#include "hsdaql.h"
//#include <conio.h>

UL32 GetTickCount();
I32 msleep(L32 msec);
#define Sleep msleep

I32 main(I32 argc, char *argv[])
{
	HANDLE hHS;
	//char IPadd[64]="\0";
    char *IPadd=NULL;
	char sdk_version[16]={0};
	char fw_version[32]={0};

	bool ret= false;
	I16 chCnt=8;
	I16  useGain=0;


	I16 extriggMode=0;
	bool continuousMode=false;
	L32 continuousTimeout=0;
	UL32 targetCnt=0;
	L32 sampleRate=0;

	//UL32 totalRead=0,totalReceived=0;
	I16 DataTransMethod=0;
	I16 AutoRun=0;
    float fAI[8];

	if(argc>1)
	{	
        printf("%d,%s\r\n",argc,argv[1]);
		//char   *pFilePathName; 
   
		//I32   nLen   =   wcslen(argv[1])+1;    
		//WideCharToMultiByte(CP_ACP,   0,   argv[1],   -1,   IPadd,  64,   NULL,   NULL);
		//printf("program start %s\r\n",IPadd);
        IPadd=argv[1];
	}
	else
	{
		printf("error argument\r\n");
		return 0;
	}

	char tmp[128]={0};
	sprintf(tmp,"%s,9999,10010",IPadd);
	//Step 1: Create a TCP connection with ET-7H16

    printf("ET-7H16 Analog Input Scan Testing [N sample mode & Software trigger]\r\n");
	HS_GetSDKVersion(sdk_version);
	printf("HSDAQ SDK Ver=%s\r\n",sdk_version);
  
	hHS = HS_Device_Create(tmp);

	Sleep(1);
	if(hHS!=NULL)
	{
		HS_GetFirmwareVersion(hHS,fw_version);
		printf("ET7H16 Firmware Ver=%s\r\n",fw_version);

		float f1AI=0;
		HS_ReadAIALL(hHS,useGain,fAI,8);
		for(I32 j=0;j<8;j++)
		{
		  HS_ReadAI(hHS,j,useGain,&f1AI);
		  printf("%d=%f, %f\r\n",j,fAI[j],f1AI);
		}
        
		extriggMode=0; //software trigger
		targetCnt=10000; //N sample mode: 10000 counts
		sampleRate=2000; //sampling rate : 1KHz 
		ret=HS_SetAIScanParam(hHS, chCnt, useGain, extriggMode, sampleRate, targetCnt, DataTransMethod,AutoRun);
		//Step 2: SetScanParam sets chCnt, useGain, triggerMode, sampleRate, targetCnt to ET7H16
		if(ret==false)
		{
			//printf("Error code 0x%x\r\n",HS_GetLastError());
            printf("Set AIscan param failed\r\n");
		}

		HS_GetAIScanParam(hHS, &chCnt, &useGain, &extriggMode, &sampleRate, &targetCnt,&DataTransMethod,&AutoRun); 
		//Step 3: GetScanParam getsx chCnt, useGain, triggerMode, sampleRate, targetCnt to check with ET7H16
		printf("ET-7H16 first Scan parameters chCnt %d, useGain %d, triggMode %d, sampleRate %ld, targetCnt %lu \n", chCnt, useGain, extriggMode, sampleRate, targetCnt);

		Sleep(10);
#if 1  
		WORD BufferStatus=0;
		I16 *dataBuffer;
        
        //#define BUFFERSIZE 1000        
		float *fdataBuffer;
		UL32 ulleng=0;
		UL32 totalRecv=0;
		UL32 otherCHcheckerror=0;
		UL32 readsize=0;	
		bool quit=false;

		/*Test N sample mode in this demo*/
		if(targetCnt>0) //N sample mode 
		{       
			//dataBuffer=(I16 *)malloc(sizeof(I16)*targetCnt);
            fdataBuffer=(float *)malloc(sizeof(float)*targetCnt);
			//Step 5: Start AI Scan            
			DWORD t1=GetTickCount();
			//Step 4: Start AI Scan           
			ret=HS_StartAIScan(hHS);
			if(ret==false)
			{
				//printf("Error code 0x%x\r\n",HS_GetLastError());
                printf("HS_StartAIScan failed\r\n");
			}

	
			//Step 5: while loop to get total received data from ET7H16Logger
			while(quit==false)
			{			
				ret=HS_GetAIBufferStatus(hHS,&BufferStatus,&ulleng);
				if(ret==false)
				{
					//printf("Error code 0x%x\r\n",HS_GetLastError());
                    printf("Error code 0x%x\r\n");
				}
				else
				{
					if(BufferStatus>2) //AI buffer overflow
					{
						/* 
						   2:  AD_BUF_OVERFLOW	
						   4:  AD_SCAN_STOP
						   8:  AD_DATA_SAMPLING_TIMEOUT
						*/
						printf("Error<%d>, %lu\r\n",BufferStatus,ulleng);	
						break; 
					}
					if(ulleng==targetCnt)
					{
						//printf(">%d \r\n",ulleng);
						UL32 size=targetCnt;	
						{							
							//readsize=HS_GetAIBufferHex(hHS,(WORD *)dataBuffer,size);
                            readsize=HS_GetAIBuffer(hHS,fdataBuffer,size);						
							
							if(readsize==targetCnt)
							{
								printf("%lu data,",readsize);
								DWORD t2=GetTickCount();
								printf("%lf sec\r\n",((float)t2-t1)/1000);                                

								for(I32 i=0;i<readsize;i++)
								{
                                    float ftemp=fdataBuffer[i%chCnt]-fAI[i%chCnt];
                                    
                                    if(ftemp<0) //abs value
                                         ftemp=(-1)*ftemp;
                                         
                                    if(ftemp>0.5)
                                    {
                                        otherCHcheckerror++;
                                        printf("%f, %f",dataBuffer[i%chCnt]-fAI[i%chCnt]);
                                    }
								/*	switch(i%chCnt)
									{	//check channel 1/3/7 only
										case 1: //1.15V 0x1d5a
										case 3:
										/*if(dataBuffer[i]>0x1d6c || dataBuffer[i]<0x1d46)
										{
											CH1checkerror++;
											printf("CH1 error %lu, %X\r\n",CH1checkerror,dataBuffer[i]);
											quit=true;																				
										}*
										break;
										case 7: //0V
										/*if(dataBuffer[i]>0x10 || dataBuffer[i]<0)
										{
											CH7checkerror++;
											printf("CH7 error %lu, %X\r\n",CH7checkerror,dataBuffer[i]);										
											quit=true;
										}*
										break;
									}
                                */
								}																
							}
							else
							{
								printf("%d \r\n",readsize);
								printf("Get AI buffer error\r\n");
							}
						}
						break;
					}
				}
				//continue mode 
			/*	if(kbhit())
				{
					//Sleep(1);
                    char ch=getchar();
                    printf("%c",ch);
					//if(getchar()=='q' || getchar()=='Q')
                    if(ch=='q' || ch=='Q')
                        goto END;
						//break;
				}*/						
			}
		
			printf("AP total read %lu Error check %lu\n", readsize,otherCHcheckerror);
			//Step6: Stop AI Scan
			HS_StopAIScan(hHS);            
			//free(dataBuffer);
            free(fdataBuffer);           
		}                      
#endif         
		//Step7: Close the connection
END:        
		HS_Device_Release(hHS);       
	}    
	return 0;
}

